{***********************************************************************
*  TKMoveBut version 1.0                                               *
*                                                                      *
*    Copyright  1997, 1998  Karlos, Inc. All Rights Reserved.         *
*    Developed By: Karlos Jorge Pinto                                  *
*    E-MAIL: Karlospinto@hotmail.com                                   *
*    Delphi Super Site o---> Delphi@pt <---o:                          *
*    http://www.terravista.pt/bilene/1412 ---> In English/Portuguese   *
*                                                                      *
************************************************************************
*  IRC: #portugal - Undernet. Nick: kArLoS.                            *
*  This is shareware, if you want to use in your projects you have to  *
*  pay *only* $5, for registrate this component. To do this please read*
*  the Register.txt, for more details.                   Made: 12/97   *
***********************************************************************}

unit Kmovebut;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, DsgnIntf;

type
   TKMoveBut = class(TBitBtn)
   procedure ButtonTimerTimer(Sender: TObject);  
   private
      FAbout: string;
      xdir, ydir: integer;           
      speed, minterval: integer;
      ButtonTimer: TTimer;
      buttonmoving: boolean;
   public

      procedure ShowAbout;Virtual;

      constructor Create(AOwner: TComponent); override;
   published
    
      property About: string read FAbout write FAbout stored False;

      property MoveInterval: integer read minterval
         write minterval default 50;
      property PixelsPerMove: integer read speed
         write speed default 1;
      property Move: boolean read buttonmoving
         write buttonmoving;
end;



   procedure Register;

implementation


type
  TAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue:string; override;
  end;

{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}


procedure TAboutProperty.Edit;

begin
  TKmovebut(GetComponent(0)).ShowAbout;
end;
function TAboutProperty.GetAttributes: TPropertyAttributes;

begin
  GetAttributes := [paDialog, paReadOnly];
end;
function TAboutProperty.GetValue: String;

begin
  GetValue := '(About Kmovebutton v.1.0)';
end;
procedure TKmovebut.ShowAbout;
var
	msg: string;
const
  cr = chr(13);
begin
  msg := '  --> The KMoveButton a Moving Button. Version: 1.0 <--' + cr;
  msg := msg + 'TKMoveButton:' + ' a 16/32-Bit Component for Delphi' + cr;
  {$IFDEF WIN32}
  msg := msg + '(This is the 32 bit version)' + cr + cr;
  {$ELSE}
  msg := msg + '(This is the 16 bit version)' + cr + cr;
  {$ENDIF}
  msg := msg + 'Copyright  1997/98 Karlos Inc.' + cr;
  msg := msg + 'Made By: Karlos Pinto' + cr;
  msg := msg + '*****************************************************************' + cr;
  msg := msg + 'Delphi@pt site: http://www.terravista.pt/bilene/1412' + cr;
  msg := msg + 'E-Mail: Karlospinto@hotmail.com' + cr;
  msg := msg + '*****************************************************************' + cr;
  msg := msg + 'This Component is SHAREWARE, please read Register.TXT.' + cr;
  msg := msg + '        ...---**** KARLOS PINTO Inc.****---...' + cr;
  msg := msg + '  IRC: #portugal - Undernet, Nick: kArLoS :)' + cr;
  msg := msg + 'If you want more comp., apz., games please send a' + cr;
  msg := msg + 'E-Mail to me, or go to the IRC, Wed 10.30 GMT. :-)' + cr;

    MessageDlg(msg,mtInformation,[MBOK],0);
end;

{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////////////////}

  procedure Register;
  begin
    RegisterComponents( 'Karlos Inc.', [ TKMoveBut ] );
    {register the 'About' property editor}
     RegisterPropertyEditor(TypeInfo(String), TKmovebut, 'About',
     TAboutProperty);

  end;
{########################################################################}
{########################################################################}
{########################################################################}
{########################################################################}
{########################################################################}


constructor TKMoveBut.Create(AOwner: TComponent);
begin                              
    inherited Create(AOwner);   
                              
                              
    minterval:=100;               
    speed:=1;                      
    xdir:=speed;
    ydir:=speed;
    width:=127;                  
    spacing:=10;                 
    font.color:=clBtnText;       
                                   
    ButtonTimer:=TTimer.Create(Self);     
    with ButtonTimer do begin
        Enabled:=true;                   
        interval:=minterval;             
        OnTimer:=ButtonTimerTimer;    
    end;
    buttonmoving:=true;                
end;

procedure TKMoveBut.ButtonTimerTimer(Sender: TObject);
begin
    try
       ButtonTimer.Interval:=minterval;  
       if xdir > 0 then xdir:=speed else xdir :=speed * -1;   
       if ydir > 0 then ydir:=speed else ydir :=speed * -1;
       if buttonmoving then begin
          if xdir > 0 then begin     
             if (left + width + xdir) <= parent.clientrect.right then
                 left := left + xdir
             else
                 xdir:=xdir * -1;  
          end
          else  { moving left }
             if (left + xdir) >= parent.clientrect.left then
                 left:=left + xdir
             else
                xdir:=xdir * -1;   
          if ydir > 0 then begin     
             if (top + height + ydir) <= parent.clientrect.bottom then
                 top := top + ydir
             else
                 ydir:=ydir * -1;
          end
          else  { moving up }
             if (top + ydir) >= parent.clientrect.top then
                 top:=top + ydir
             else
                ydir:=ydir * -1;
       end;
    except

       ButtonTimer.Enabled:=false;
    end;
end;

end.
